package com.prank.tool.sounds.app.fragment;

import android.Manifest;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.net.Uri;
import android.os.Build;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Toast;

import androidx.activity.result.ActivityResultCallback;
import androidx.activity.result.ActivityResultLauncher;
import androidx.activity.result.contract.ActivityResultContracts;
import androidx.core.content.ContextCompat;
import androidx.fragment.app.Fragment;
import androidx.recyclerview.widget.GridLayoutManager;

import com.prank.tool.sounds.app.activity.ViewRecorderSound;
import com.prank.tool.sounds.app.activity.ViewSaveSound;
import com.prank.tool.sounds.app.adapter.AdaLike;
import com.prank.tool.sounds.app.common.MyItemDecoration;
import com.prank.tool.sounds.app.common.MyUtils;
import com.prank.tool.sounds.app.data.Db;
import com.prank.tool.sounds.app.data.OnType;
import com.prank.tool.sounds.app.data.detail;
import com.prank.tool.sounds.app.databinding.FragmentMicBinding;

import java.util.List;
import java.util.Map;


public class FragmentMic extends Fragment implements View.OnClickListener , OnType {

    private FragmentMicBinding binding;
    private AdaLike adapter;
    private ActivityResultLauncher<String> requestRecordAudioLauncher;
    private ActivityResultLauncher<String> audioPickerLauncher;
    private ActivityResultLauncher<String[]> requestStorePermissionsLauncher;

    public FragmentMic() {

    }

    public static FragmentMic newInstance() {
        FragmentMic fragment = new FragmentMic();
        Bundle args = new Bundle();

        fragment.setArguments(args);
        return fragment;
    }

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        requestRecordAudioLauncher = registerForActivityResult(
                new ActivityResultContracts.RequestPermission(),
                isGranted -> {
                    if (isGranted) {
                        intentRecordAudio();
                    } else {
                        Toast.makeText(requireContext(), "Recording permission denied", Toast.LENGTH_SHORT).show();
                    }
                }
        );

        requestStorePermissionsLauncher = registerForActivityResult(
                new ActivityResultContracts.RequestMultiplePermissions(),
                new ActivityResultCallback<Map<String, Boolean>>() {
                    @Override
                    public void onActivityResult(Map<String, Boolean> result) {
                        Boolean isGranted = true;
                        for (Map.Entry<String, Boolean> entry : result.entrySet()) {
                            String permission = entry.getKey();
                            isGranted = entry.getValue();
                            if(!entry.getValue()){
                                isGranted = false;
                            }

                        }
                        if (isGranted) {
                            importAudio();
                        }else {
                            Toast.makeText(requireContext(),   " 权限被拒绝", Toast.LENGTH_SHORT).show();
                        }
                    }
                }
        );
        audioPickerLauncher = registerForActivityResult(new ActivityResultContracts.GetContent(),
                new ActivityResultCallback<Uri>() {
                    @Override
                    public void onActivityResult(Uri uri) {
                        // Handle the returned Uri

                        if (uri != null) {
                            long duration = MyUtils.getAudioDuration(requireContext(), uri);
                            Intent intent = new Intent(requireContext(), ViewSaveSound.class);
                            intent.putExtra(ViewSaveSound.KEY_Path, uri.toString());
                            intent.putExtra(ViewSaveSound.KEY_Time, duration);
                            startActivity(intent);
                        }
                    }
                });


    }
    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        binding = FragmentMicBinding.inflate(getLayoutInflater());


        MyItemDecoration itemHelper = new MyItemDecoration(10, 10, 5);
        binding.recyclerImport.addItemDecoration(itemHelper);
        binding.recyclerImport.setLayoutManager(new GridLayoutManager(requireContext(), 2));
        List<detail> all = Db.getAllCustomization();
//        updateUi(all);
        adapter = new AdaLike(requireContext(), all,true);
        binding.recyclerImport.setAdapter(adapter);
        binding.btnimport.setOnClickListener(this);
        binding.record.setOnClickListener(this);

        return binding.getRoot();
    }





    public void refresh() {
        if (adapter != null) {
            List<detail> all = Db.getAllCustomization();
//            updateUi(all);
            adapter.updateData(all);
        }

    }

//    private void updateUi(List<Info> all) {
//        if (all.size() == 0) {
//            binding.noImportHint.setVisibility(View.VISIBLE);
//            binding.recyclerImport.setVisibility(View.GONE);
//        } else {
//            binding.noImportHint.setVisibility(View.GONE);
//            binding.recyclerImport.setVisibility(View.VISIBLE);
//        }
//    }

    private void checkAndRequestAudioPermission() {
        if (ContextCompat.checkSelfPermission(requireContext(), MyUtils.permission_record_audio)
                != PackageManager.PERMISSION_GRANTED) {
            requestRecordAudioLauncher.launch(MyUtils.permission_record_audio);
        } else {
            intentRecordAudio();
        }
    }

    private void intentRecordAudio() {
        Intent intent = new Intent(requireContext(), ViewRecorderSound.class);
        startActivity(intent);
    }

    @Override
    public void onClick(View v) {
         if(v.equals(binding.btnimport)){
             onClickTimerListener(0);
        }else if(v.equals(binding.record)){
             onClickTimerListener(1);
         }
    }



    private void importAudio() {
        Intent intent = new Intent(Intent.ACTION_GET_CONTENT);
        intent.setType("audio/*");
        audioPickerLauncher.launch("audio/*");

    }



    public void onClickTimerListener(int type) {
        switch (type){
            case 0:
                if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.TIRAMISU) {
                    if (ContextCompat.checkSelfPermission(requireContext(), MyUtils.permission_read_audio[0])
                            != PackageManager.PERMISSION_GRANTED) {
                        requestStorePermissionsLauncher.launch(MyUtils.permission_read_audio);
//                    ActivityCompat.requestPermissions(requireActivity(), ConstValues.permission_read_audio,
//                            ConstValues.REQUEST_READ_STORAGE_PERMISSION);
                    } else {
                        importAudio();
                    }
                } else {
                    if (ContextCompat.checkSelfPermission(requireContext(), Manifest.permission.WRITE_EXTERNAL_STORAGE)
                            != PackageManager.PERMISSION_GRANTED ||
                            ContextCompat.checkSelfPermission(requireContext(), Manifest.permission.READ_EXTERNAL_STORAGE)
                                    != PackageManager.PERMISSION_GRANTED) {
                        requestStorePermissionsLauncher.launch(MyUtils.permission_store);
//                    ActivityCompat.requestPermissions(requireActivity(), ConstValues.permission_store, ConstValues.REQUEST_READ_STORAGE_PERMISSION);
                    } else {
                        importAudio();
                    }
                }
                break;
            case 1:
                checkAndRequestAudioPermission();
                break;
        }
    }
}